-- CREACIN DE TABLAS

CREATE TABLE inv_dispositivo (
	cod_disp				NUMBER(9) NOT NULL,
	num_serie_disp			VARCHAR2(200 CHAR),
	fec_validacion_inv		DATE,
	es_departamental_disp	CHAR(1) default 0 check (es_departamental_disp in (0,1)) , --0: false 1: true
	fec_compra_disp			DATE,
	precio_compra_disp		NUMBER(10,2) NOT NULL, 
	comentario_disp			VARCHAR2(2000 CHAR),
	cod_inventario			NUMBER(9),
	cod_producto			NUMBER(9) NOT NULL,
	cod_empleado			NUMBER(9), 
	cod_sede				NUMBER(9) NOT NULL -- Aadido, no estaba en el diseo
);

CREATE TABLE inv_tipo_producto (
	cod_tipo_prod			NUMBER(9) NOT NULL,
	desc_tipo_prod			VARCHAR2(200 CHAR)
);

CREATE TABLE inv_producto (
	cod_prod				NUMBER(9) NOT NULL,
	nombre_prod				VARCHAR2(200 CHAR),
	desc_prod				VARCHAR2(2000 CHAR),
	cod_tipo_prod			NUMBER(9) NOT NULL,
	cod_marca_prod			NUMBER(9) NOT NULL
);

CREATE TABLE inv_marca (
	cod_marca				NUMBER(9) NOT NULL,
	nom_marca				VARCHAR2(200 CHAR) NOT NULL,
	desc_marca				VARCHAR2(2000 CHAR),
	url_marca				VARCHAR2(1000 CHAR),
	tel_marca				VARCHAR2(12 CHAR),
	email_soporte_marca		VARCHAR2(1000 CHAR),
	persona_contacto_marca	VARCHAR2(1000 CHAR)
);

CREATE TABLE inv_movimiento (
	cod_mov					NUMBER(9) NOT NULL,
	cod_disp  				NUMBER(9) NOT NULL,
	fecha_mov				DATE NOT NULL,
	usu_origen_mov			NUMBER(9),
	usu_dest_mov			NUMBER(9),
	cod_tipo_mov			NUMBER(9) NOT NULL,
	desc_mov				VARCHAR2(2000 CHAR)
	);

CREATE TABLE inv_tipo_movimiento (
	cod_tipo_mov			NUMBER(9) NOT NULL,
	desc_tipo_mov			VARCHAR2(2000 CHAR) NOT NULL
);

CREATE TABLE inv_empleado (
	cod_emp					NUMBER(9) NOT NULL,
	NIF_emp					VARCHAR2(20 CHAR) NOT NULL,
	nombre_emp				VARCHAR2(200 CHAR) NOT NULL,
	apellidos_emp			VARCHAR2(1000 CHAR) NOT NULL,
	telefono_emp			VARCHAR2(12 CHAR),
	fecha_nac_emp			DATE,
	sexo_emp				VARCHAR2(1 CHAR) check (sexo_emp in ('H','M')),
	email_emp				VARCHAR2(200 CHAR),
    estado_emp     			VARCHAR2(1 CHAR) check (estado_emp in ('A','B','E')), --A: ALTA, B:BAJA, E:EXCEDENCIA
	cod_dep_emp				NUMBER(9) NOT NULL,
	cod_sede_emp			NUMBER(9) NOT NULL
);

CREATE TABLE inv_departamento (
	cod_dep					NUMBER(9) NOT NULL,
	nom_dep					VARCHAR2(200 CHAR) NOT NULL,
	desc_dep				VARCHAR2(2000 CHAR),
	cod_responsable_dep		NUMBER(9)
);

CREATE TABLE inv_pedido (
	cod_pedido			    NUMBER(9) NOT NULL,
	fec_realizacion_ped		DATE,
	fec_validacion_ped		DATE,
	resp_autorizar_ped		NUMBER(9),
	esta_autorizado_ped		CHAR(1 CHAR) default 0 check (esta_autorizado_ped in (0,1)), --0 = falso 1= autorizado resp. dep 
	resp_financiero_ped		NUMBER(9),
	fec_ok_financiero_ped	DATE,
	importe_ped				NUMBER(20,2),
	tipo_gasto_ped		  	CHAR(1 CHAR) check (tipo_gasto_ped in ('G','I')),
	fec_solicitud_ped		DATE,
	fec_recepcion_ped		DATE,
	motivo_denega_ped		VARCHAR2(2000 CHAR), -- Espacio para comentarios
	provee_ped			    NUMBER(9)
); 

CREATE TABLE inv_linea_pedido (
	cod_lineap				NUMBER(9) NOT NULL,
	cantidad_lineap			NUMBER(7),
	cod_producto_lineap		NUMBER(9) NOT NULL,
	cod_pedido_lineap		NUMBER(9) NOT NULL
);

CREATE TABLE inv_proveedor (
	cod_prov				NUMBER(9) NOT NULL,
	CIF_prov				VARCHAR2(12 CHAR) NOT NULL,
	nombre_prov				VARCHAR2(200 CHAR) NOT NULL,
	direccion_prov			VARCHAR2(2000 CHAR),
	contacto_prov			VARCHAR2(400 CHAR),
	email_prov				VARCHAR2(400 CHAR),
	telefono_prov			VARCHAR2(20 CHAR)
);

CREATE TABLE inv_inventario (
	cod_inv					NUMBER(9)	 NOT NULL,
	sede_inv				NUMBER(9)	 NOT NULL,
	fecha_inv				DATE		 NOT NULL,
	emp_responsable_inv		NUMBER(9) 	NOT NULL
);

CREATE TABLE inv_presupuesto (
	cod_presup				NUMBER(9) NOT NULL,
	fec_presup				DATE,
    importe_presup  	    NUMBER(20,2), 
	validez_presup			DATE,
	cod_provee_presup		NUMBER(9),
	cod_pedido_presup		NUMBER(9),
	fecha_entrega_presup	DATE
);

CREATE TABLE inv_sede (
	cod_sede				NUMBER(9)		 NOT NULL,
	nom_sede				VARCHAR2(200 CHAR)	 NOT NULL,
	pais_sede				VARCHAR2(200 CHAR),
	localidad_sede			VARCHAR2(200 CHAR),
	cod_postal_sede			VARCHAR2(10 CHAR),
	nom_via_sede			VARCHAR2(200 CHAR),
	numero_via_sede			VARCHAR2(20 CHAR),
	piso_sede				VARCHAR2(20 CHAR),
	puerta_sede				VARCHAR2(20 CHAR),
	cod_dep_sede			NUMBER(9) NOT NULL
);

CREATE TABLE inv_log (
	cod_log					NUMBER(9) NOT NULL,
	fecha_log				DATE,
	funcion_log				VARCHAR2(100 CHAR),
	param_in_log			VARCHAR2(1000 CHAR),
	param_out_log			VARCHAR2(1000 CHAR),
	usuario_log				VARCHAR2(100 CHAR)
);