-- PRIMARY KEYS

ALTER TABLE inv_dispositivo ADD (
  CONSTRAINT inv_dispositivo_pk PRIMARY KEY (cod_disp) USING INDEX
);


ALTER TABLE inv_tipo_producto ADD (
	CONSTRAINT inv_tipo_producto_pk PRIMARY KEY (cod_tipo_prod) USING INDEX);
	
ALTER TABLE inv_producto ADD (
  CONSTRAINT inv_producto_pk PRIMARY KEY (cod_prod) USING INDEX
);

ALTER TABLE inv_marca ADD (
	CONSTRAINT inv_marca_pk PRIMARY KEY (cod_marca) USING INDEX);
	
ALTER TABLE inv_movimiento ADD (
	CONSTRAINT inv_movimiento_pk PRIMARY KEY (cod_mov) USING INDEX);	
	
	
ALTER TABLE inv_tipo_movimiento ADD (
	CONSTRAINT inv_tipo_movimiento_pk PRIMARY KEY (cod_tipo_mov) USING INDEX);		
	
ALTER TABLE inv_empleado ADD (
	CONSTRAINT inv_empleado_pk PRIMARY KEY (cod_emp) USING INDEX);	
	
ALTER TABLE inv_departamento ADD (
	CONSTRAINT inv_departamento_pk PRIMARY KEY (cod_dep) USING INDEX);	
	
ALTER TABLE inv_pedido ADD (
	CONSTRAINT inv_pedido_pk PRIMARY KEY (cod_pedido) USING INDEX);
	
ALTER TABLE inv_linea_pedido ADD (
	CONSTRAINT inv_linea_pedido_pk PRIMARY KEY (cod_lineap) USING INDEX);	
	
ALTER TABLE inv_proveedor ADD (
	CONSTRAINT inv_proveedor_pk PRIMARY KEY (cod_prov) USING INDEX);
	
ALTER TABLE inv_inventario ADD (
	CONSTRAINT inv_inventario_pk PRIMARY KEY (cod_inv) USING INDEX);	

ALTER TABLE inv_presupuesto ADD (
	CONSTRAINT inv_presupuesto_pk PRIMARY KEY (cod_presup) USING INDEX);
	

ALTER TABLE inv_sede ADD (
	CONSTRAINT inv_sede_pk PRIMARY KEY (cod_sede) USING INDEX);
	
ALTER TABLE inv_log ADD (
	CONSTRAINT inv_log_pk PRIMARY KEY (cod_log) USING INDEX);

	
-- UNIQUE KEYS
	
ALTER TABLE inv_dispositivo ADD (
  CONSTRAINT inv_dispositivo_num_serie_uk UNIQUE (num_serie_disp)
);

ALTER TABLE inv_empleado ADD (
  CONSTRAINT inv_empleado_nif_uk UNIQUE (NIF_emp)
);

ALTER TABLE inv_proveedor ADD (
  CONSTRAINT inv_proveedor_cif UNIQUE (CIF_prov)
);

ALTER TABLE inv_sede ADD (
  CONSTRAINT inv_sede_nombre UNIQUE (nom_sede)
);

ALTER TABLE inv_departamento ADD (
  CONSTRAINT inv_departamento_nombre UNIQUE (nom_dep)
);

-- FOREIGN KEYS I UNIQUE KEYS

ALTER TABLE inv_dispositivo ADD CONSTRAINT inv_dispositivo_inventario_fk FOREIGN KEY (cod_inventario) REFERENCES inv_inventario(cod_inv);
ALTER TABLE inv_dispositivo ADD CONSTRAINT inv_dispositivo_producto_fk FOREIGN KEY (cod_producto) REFERENCES inv_producto(cod_prod);
ALTER TABLE inv_dispositivo ADD CONSTRAINT inv_dispositivo_empleado_fk FOREIGN KEY (cod_empleado) REFERENCES inv_empleado(cod_emp);
ALTER TABLE inv_dispositivo ADD CONSTRAINT inv_dispositivo_sede_fk FOREIGN KEY (cod_sede) REFERENCES inv_sede(cod_sede);


ALTER TABLE inv_producto ADD (
  CONSTRAINT inv_producto_tipo_prod_fk FOREIGN KEY (cod_tipo_prod) REFERENCES inv_tipo_producto(cod_tipo_prod),
  CONSTRAINT inv_producto_marca_fk FOREIGN KEY (cod_marca_prod) REFERENCES inv_marca(cod_marca)
);


ALTER TABLE inv_movimiento ADD (
	CONSTRAINT inv_movimiento_usu_origen_fk FOREIGN KEY (usu_origen_mov) REFERENCES inv_empleado(cod_emp),
	CONSTRAINT inv_movimiento_cod_disp_fk 	FOREIGN KEY (cod_disp) REFERENCES inv_dispositivo(cod_disp),
	CONSTRAINT inv_movimiento_usu_dest_fk FOREIGN KEY (usu_dest_mov) REFERENCES inv_empleado(cod_emp)
);

ALTER TABLE inv_empleado ADD (
	CONSTRAINT inv_empleado_departamento_fk FOREIGN KEY (cod_dep_emp) REFERENCES inv_departamento(cod_dep),
	CONSTRAINT inv_empleado_sede_fk FOREIGN KEY (cod_sede_emp) REFERENCES inv_sede(cod_sede)
);

ALTER TABLE inv_departamento ADD (
	CONSTRAINT inv_departamento_empleado_fk FOREIGN KEY (cod_responsable_dep) REFERENCES inv_empleado(cod_emp)
);

ALTER TABLE inv_pedido ADD (
	CONSTRAINT inv_pedido_empleado_resp_fk FOREIGN KEY (resp_autorizar_ped) REFERENCES inv_empleado(cod_emp),
	CONSTRAINT inv_pedido_empleado_finan_fk FOREIGN KEY (resp_financiero_ped) REFERENCES inv_empleado(cod_emp),
	CONSTRAINT inv_pedido_proveedor_fk FOREIGN KEY (provee_ped) REFERENCES inv_proveedor(cod_prov)
);


ALTER TABLE inv_linea_pedido ADD (
	CONSTRAINT inv_lineap_producto_fk FOREIGN KEY (cod_producto_lineap) REFERENCES inv_producto(cod_prod),
	CONSTRAINT inv_lineap_pedido_fk FOREIGN KEY (cod_pedido_lineap) REFERENCES inv_pedido(cod_pedido)
);

ALTER TABLE inv_inventario ADD (
	CONSTRAINT inv_inventario_sede_fk FOREIGN KEY (sede_inv) REFERENCES inv_sede(cod_sede),
	CONSTRAINT inv_inventario_empleado_fk FOREIGN KEY (emp_responsable_inv) REFERENCES inv_empleado(cod_emp)
);

ALTER TABLE inv_presupuesto ADD (
	CONSTRAINT inv_presupuesto_proveedor_fk FOREIGN KEY (cod_provee_presup) REFERENCES inv_proveedor(cod_prov),
	CONSTRAINT inv_presupuesto_pedido_fk FOREIGN KEY (cod_pedido_presup) REFERENCES inv_pedido(cod_pedido)
);


ALTER TABLE inv_sede ADD (
	CONSTRAINT inv_sede_departamento_fk	FOREIGN KEY (cod_dep_sede) REFERENCES inv_departamento(cod_dep)
  );