CREATE OR REPLACE PACKAGE ESTADISTICAS_DWH_PQ AS

  -- Procedimientos para dar soporte a Q1
  PROCEDURE EST_Nuevo_dispositivo (p_anyo IN INTEGER);
  -- Procedimientos para dar soporte a Q2
  PROCEDURE EST_Nuevo_portatil;
  PROCEDURE EST_Baja_portatil;
  PROCEDURE EST_Nueva_Averia_portatil (p_cod_disp IN NUMBER);
  -- Procedimientos para dar soporte a Q3
  PROCEDURE EST_Actualiza_importe_INv(p_anyo IN INTEGER,p_importe IN NUMBER);
  -- Procedimientos para dar soporte a Q4
  -- Incrementa el nmero de pedidos servidos por ese proveedor 
  -- Tambin Indica los das entre que se solicit el pedido y cuando se recibi
  PROCEDURE EST_Nuevo_pedido_servido(p_provee IN NUMBER, p_dias IN INTEGER); 
  -- Procedimiento estadstica Q5
  PROCEDURE EST_Nuevo_dispositivo_en_uso (p_dep IN INTEGER);
  PROCEDURE EST_Retira_dispositivo_en_uso (p_dep IN INTEGER);
  -- Procedimiento estadstica Q8
  PROCEDURE EST_Nueva_reasignacion (p_dep IN INTEGER);
  -- Procedimiento estadstico Q6
  PROCEDURE EST_Suma_valor_inv_activo (p_dep IN NUMBER, p_importe IN NUMBER);
  PROCEDURE EST_Resta_valor_inv_activo (p_dep IN NUMBER, p_importe IN NUMBER);
  -- Procedimientos estadstico Q9 y Q12
  PROCEDURE EST_Nuevo_empleado;
  PROCEDURE EST_Baja_empleado;
  PROCEDURE EST_Nueva_asignacion_disp (p_cod_emp IN INV_EMPLEADO.cod_emp%TYPE);
  PROCEDURE EST_Retirada_dipositivo (p_cod_emp IN INV_EMPLEADO.cod_emp%TYPE);
  -- Procedimientos estadsticos Q10
  PROCEDURE EST_disp_almacenado(p_cod_disp IN INV_DISPOSITIVO.cod_disp%TYPE);
  PROCEDURE EST_disp_entregado(p_cod_disp IN INV_DISPOSITIVO.cod_disp%TYPE); --entregado
  -- Procedimientos estadstico Q11
  PROCEDURE EST_suma_disp_diferente(p_dep IN INV_DEPARTAMENTO.cod_dep%TYPE,p_cod_disp IN NUMBER);
  PROCEDURE EST_resta_disp_diferente(p_dep IN INV_DEPARTAMENTO.cod_dep%TYPE,p_cod_disp IN NUMBER);
   -- Procedimiento estadstica Q13
  PROCEDURE EST_Nueva_averia (p_anyo IN INTEGER);
  -- Procedimiento estadsica Q14
  PROCEDURE EST_Calcula_averias;
END ESTADISTICAS_DWH_PQ;


