CREATE OR REPLACE PACKAGE INVENTARIO_PQ AS

/*
Descripcin:		 Alta inventario
Requisitos:			 Rol administrador o rol encargado de inventario
Parmetro entrada:
					*P_Sede_inventario
					*P_Fecha_inventario
					*Empleado_responsable_inv
Parmetro de salida
					Si todo ha ido bien:
					RSP = 'OK: Alta inventario con el Id = cod_inventario '
					Mensajes de error:
						'ERROR: hay campos obligatorios sin rellenar'
						'ERROR: El dispositivo no existe en el sistema'
						'ERROR: El dispositivo ya existe en el sistema'
PRE-CONDICIN
POST-CONDICIN 		RSP
					Registra accin en el log del sistema*/

PROCEDURE INV_GEST_INV_ALTA_PR(
			p_sede_inventario IN INV_INVENTARIO.sede_inv%TYPE,
			p_fecha_inv IN DATE,
			p_empleado_responsable IN INV_INVENTARIO.emp_responsable_inv%TYPE,
			RSP OUT VARCHAR2,
			COD_NUEVO_INV OUT INV_INVENTARIO.cod_inv%TYPE);
  
  
  
/*Descripcin:		 Alta dispositivo en inventario
Requisitos:			 Rol administrador o rol encargado de inventario
Parmetro entrada:
					*P_cod_inventario
					*p_cod_dispositivo
Parmetro de salida
					RSP
PRE-CONDICIN
POST-CONDICIN 		Registra accin en el log del sistema
					Registra el dispositivo en un inventario
					Devuelve 
						Si todo ha ido bien:
							RSP = 'OK: Alta dispositivo en inventario '
						Mensajes de error:
						'ERROR: hay campos obligatorios sin rellenar'
						'ERROR: El dispositivo no existe en el sistema'
						'ERROR: El inventario no existe en el sistema'
*/
  -- INVENTARIA DISPOSITIVO
  PROCEDURE INV_GEST_INVENTARIA_DISP_PR(P_cod_inventario IN INV_INVENTARIO.cod_inv%TYPE,
									P_cod_dispositivo IN INV_DISPOSITIVO.cod_disp%TYPE,
                  RSP OUT VARCHAR2);

END INVENTARIO_PQ;


