CREATE OR REPLACE PACKAGE BODY LISTADOS_ESTADISTICOS_PQ AS

	PROCEDURE Q1_DISPOSITIVOS_COMPRADOS (P_ANY INTEGER) IS
    v_Num_disp_comprados number;
	BEGIN
		-- CABECERAS
      DBMS_OUTPUT.PUT_LINE('###Q1: Listado de dispositivos comprados ('|| to_date(SYSDATE,'DD/MM/YYYY') ||')###');

      BEGIN
        select Num_disp_comprados into v_Num_disp_comprados from R1 where anyo=p_any;
      END;
    DBMS_OUTPUT.PUT_LINE('Ao: '||P_ANY||' / Nmero de dispositivos comprados: '||v_Num_disp_comprados);				
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      DBMS_OUTPUT.PUT_LINE('Ao: '||P_ANY||' / Nmero de dispositivos comprados: 0');				
	END Q1_DISPOSITIVOS_COMPRADOS;
  
  PROCEDURE Q2_AVERIAS_PORTATIL IS
    v_num_portatiles number;
    v_num_portatiles_averiados number;
    v_porcentaje  number;
    v_num_portatiles_no_averiados number;
  BEGIN
      -- CABECERAS
    DBMS_OUTPUT.PUT_LINE('###Q2: Porcentaje porttiles NO averiados ('|| to_date(SYSDATE,'DD/MM/YYYY') ||')###');
    BEGIN
      select num_portatiles, num_portatiles_averiados into v_num_portatiles,v_num_portatiles_averiados from R6;
    END;
    v_num_portatiles_no_averiados := v_num_portatiles-v_num_portatiles_averiados;
    v_porcentaje := 100*(v_num_portatiles_no_averiados/v_num_portatiles);
    DBMS_OUTPUT.PUT_LINE('% Porttiles sin averas: '||v_porcentaje||'%'|| ' / Total porttiles: '||v_num_portatiles|| ' / Sin averas: ' || v_num_portatiles_no_averiados);
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      DBMS_OUTPUT.PUT_LINE('Sin averias registradas en porttiles');
  END Q2_AVERIAS_PORTATIL;
  
  PROCEDURE Q3_INVERSION_PEDIDOS (P_ANY INTEGER) IS
    v_importe number(10,2);
  BEGIN
	-- CABECERAS
      DBMS_OUTPUT.PUT_LINE('###Q3: Importe pedidos ligados a orden de inversin ('|| to_date(SYSDATE,'DD/MM/YYYY') ||')###');
      BEGIN
        select importe_orden_inversion into v_importe from R1 where anyo=p_any;
      END;
    DBMS_OUTPUT.PUT_LINE('Ao: '||P_ANY|| ' / Importe inversin: '||v_importe||'');	--to_char(v_importe,'9.999.999,00')			

  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      DBMS_OUTPUT.PUT_LINE('Ao: '||P_ANY|| ' / Importe inversin: 0 ');
  END Q3_INVERSION_PEDIDOS;

PROCEDURE Q4_PROVEEDOR_MAS_RAPIDO IS
  v_nom_provee varchar2(100);
  v_cod_provee number;
  v_dias number; --dias promedio para realizar entrega
BEGIN
  DBMS_OUTPUT.PUT_LINE('###Q4: Proveedor con periodos de entrega promedio ms corto ('|| to_date(SYSDATE,'DD/MM/YYYY') ||')###');
  BEGIN    
    SELECT cod_prov,dias_delay/total_pedidos_servidos periodo_entrega
    INTO v_cod_provee,v_dias 
    FROM R3 
    WHERE dias_delay/total_pedidos_servidos = (select min(dias_delay/total_pedidos_servidos) from R3) AND rownum = 1
    ORDER BY periodo_entrega asc;
    -- promedio dias entrega = dias_delay / total_pedidos_servidos
    -- a partir de cdigo averiaguamos el nombre del proveedor
    select nombre_prov into v_nom_provee from INV_PROVEEDOR where cod_prov = v_cod_provee;
  END;
  DBMS_OUTPUT.PUT_LINE('Proveedor con mejor tiempo de entrega: '||v_nom_provee||' con '||v_dias || ' das');
EXCEPTION
    WHEN NO_DATA_FOUND THEN
      DBMS_OUTPUT.PUT_LINE(' No hay estadsticas de tiempos de entrega de proveedores');
  END Q4_PROVEEDOR_MAS_RAPIDO;

PROCEDURE Q5_DISPOSITIVOS_ACTIVOS (P_NOM_DEP VARCHAR2) IS
  v_num_dep number;
  v_num_disp_activos number;
  v_cod_dep varchar2(100);
BEGIN
  DBMS_OUTPUT.PUT_LINE('###Q5: Departamento que tiene ms dispositivos activos ('|| to_date(SYSDATE,'DD/MM/YYYY') ||')###');
  BEGIN
    select cod_dep into v_cod_dep from INV_DEPARTAMENTO where nom_dep = p_nom_dep;
    select num_disp_activos into v_num_disp_activos from R2 where cod_dep = v_cod_dep;
  END;
  DBMS_OUTPUT.PUT_LINE('Dispositivos activos de '||p_nom_dep||':'||v_num_disp_activos);
EXCEPTION
    WHEN NO_DATA_FOUND THEN
      DBMS_OUTPUT.PUT_LINE(P_NOM_DEP||' No tiene dispositivos activos en este momento');
END Q5_DISPOSITIVOS_ACTIVOS;



PROCEDURE Q6_VALOR_ECON_ACTIVOS (P_NOM_DEP VARCHAR2) IS
 v_num_dep number;
  v_valor_activos number;
  v_cod_dep varchar2(100);
BEGIN
  DBMS_OUTPUT.PUT_LINE('###Q6: Valor econmico de los dispositivos activos ('|| to_date(SYSDATE,'DD/MM/YYYY') ||')###');
  BEGIN
    select cod_dep into v_cod_dep from INV_DEPARTAMENTO where nom_dep = p_nom_dep;
    select valor_econ_inventario_activo into v_valor_activos from R2 where cod_dep = v_cod_dep;
  END;
  DBMS_OUTPUT.PUT_LINE('Valor econmico del inventario activo de '||p_nom_dep||':'||v_valor_activos||'');
EXCEPTION
    WHEN NO_DATA_FOUND THEN
      DBMS_OUTPUT.PUT_LINE(P_NOM_DEP||' No tiene valor econnico para sus dispositivos');
END Q6_VALOR_ECON_ACTIVOS;
  
  
  
PROCEDURE Q8_DEPARTAMENTO_MAS_REASIGNA IS
  v_num_dep number;
  v_num_reasignaciones number;
  v_nom_dep varchar2(100);
BEGIN
  DBMS_OUTPUT.PUT_LINE('###Q8: Departamento que ms reasigna ('|| to_date(SYSDATE,'DD/MM/YYYY') ||')###');
  BEGIN
    select cod_dep,total_reasignaciones into v_num_dep,v_num_reasignaciones from R2 where total_reasignaciones = (select max(total_reasignaciones) from R2) and rownum = 1;
    select nom_dep into v_nom_dep from inv_departamento where cod_dep = v_num_dep;
  END;
  DBMS_OUTPUT.PUT_LINE('Departamento con ms reasignaciones: '||v_nom_dep||'('||v_num_reasignaciones||')');
EXCEPTION
    WHEN NO_DATA_FOUND THEN
      DBMS_OUTPUT.PUT_LINE('No hay departamentos registrados');
END;

 -- Porcentaje de empleado sin dispositivo asignado
PROCEDURE Q9_PORCENTAJE_EMP_SIN_DISP IS 
  v_porcentaje number;
BEGIN
  DBMS_OUTPUT.PUT_LINE('###Q9: Porcentaje de empleados sin dispositivo asignado ('|| to_date(SYSDATE,'DD/MM/YYYY') ||')###');
  BEGIN
    select 100*((total_empleados-empleados_con_dispositivo)/total_empleados) into v_porcentaje from R4;
  END;
  DBMS_OUTPUT.PUT_LINE('% Empleados sin dispositivo asignado: '||ROUND(v_porcentaje,1)||'%');
EXCEPTION
    WHEN NO_DATA_FOUND THEN
      DBMS_OUTPUT.PUT_LINE('No hay datos');
END;

---- Dispositivos pendientes de asignar
PROCEDURE Q10_DISP_PENDIENTES_ASIGNAR IS 
  v_desc varchar2(100 char);
BEGIN
  DBMS_OUTPUT.PUT_LINE('###Q10: Dispositivos pendientes de asignar ('|| to_date(SYSDATE,'DD/MM/YYYY') ||')###');
  FOR R5_rec IN (SELECT * FROM R5)
  LOOP
      SELECT desc_tipo_prod INTO v_desc FROM INV_TIPO_PRODUCTO WHERE cod_tipo_prod=R5_rec.tipo_dispositivo;
      DBMS_OUTPUT.put_line(v_desc || '-' ||R5_rec.unidades_pendientes_asignar||' uds.');
  END LOOP;
EXCEPTION
    WHEN NO_DATA_FOUND THEN
      DBMS_OUTPUT.PUT_LINE('No hay datos');
END;


PROCEDURE Q11_DISP_DIFERENTES IS
  v_num_dep number;
  v_num_disp number;
  v_nom_dep varchar2(100);
BEGIN
  DBMS_OUTPUT.PUT_LINE('###Q11: Departamento con ms dispositivos ('|| to_date(SYSDATE,'DD/MM/YYYY') ||')###');
  BEGIN
    select cod_dep,num_disp_diferente into v_num_dep,v_num_disp from R2  where num_disp_diferente = (select max(num_disp_diferente) from R2) and rownum = 1;
    select nom_dep into v_nom_dep from inv_departamento where cod_dep = v_num_dep;
  END;
  DBMS_OUTPUT.PUT_LINE('Departamento con ms dispositivos diferentes: '||v_nom_dep||'('||v_num_disp||')');
EXCEPTION
    WHEN NO_DATA_FOUND THEN
      DBMS_OUTPUT.PUT_LINE('No hay datos');
END Q11_DISP_DIFERENTES;

--Empleados con ms de 5 dispositivos asignados
PROCEDURE Q12_EMP_MAS_5_DISP IS
  v_total number;
BEGIN
  DBMS_OUTPUT.PUT_LINE('###Q12: Nmero de empleados con ms de 5 dispositivos asignados ('|| to_date(SYSDATE,'DD/MM/YYYY') ||')###');
  BEGIN
    select empleados_mas_de_5_disp into v_total from R4;
  END;
  DBMS_OUTPUT.PUT_LINE('Nmero de empleados con ms de 5 dispositivos asignados: '||v_total);
EXCEPTION
    WHEN NO_DATA_FOUND THEN
      DBMS_OUTPUT.PUT_LINE('No hay registrados empleados con ms de 5 dispositivos');
END;

PROCEDURE Q13_AVERIAS (P_ANY INTEGER) IS	
   v_averias number;
  BEGIN
	-- CABECERAS
      DBMS_OUTPUT.PUT_LINE('###Q13: Nmero de averas ('|| to_date(SYSDATE,'DD/MM/YYYY') ||')###');
      BEGIN
        select Num_total_averias into v_averias from R1 where anyo=p_any;
      END;
    DBMS_OUTPUT.PUT_LINE('Ao: '||P_ANY|| ' / Nmero de averas: '||v_averias);	

  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      DBMS_OUTPUT.PUT_LINE('Ao: '||P_ANY|| ' / Nmero de averas: 0');
END;

PROCEDURE Q14_USUARIOS_AVERIAS IS	
 v_nom_empleado varchar2(1000 char);
BEGIN
  DBMS_OUTPUT.PUT_LINE('###Q14: Usuarios con ms averas registradas ('|| to_date(SYSDATE,'DD/MM/YYYY') ||')###');
  FOR R7_rec IN (SELECT * FROM R7)
  LOOP
      SELECT nombre_emp || ' ' || apellidos_emp INTO v_nom_empleado FROM INV_EMPLEADO WHERE cod_emp=R7_rec.cod_usuari;
      DBMS_OUTPUT.put_line(v_nom_empleado || '-' ||R7_rec.num_averias);
  END LOOP;
EXCEPTION
    WHEN NO_DATA_FOUND THEN
      DBMS_OUTPUT.PUT_LINE('No hay datos');
END;

END LISTADOS_ESTADISTICOS_PQ ;