-- PRUEBAS PARA VERIFICAR LOS MENSAJES DE ERROR ANTES ANOMALAS EN LA ENTRADA DE DATOS A LOS PROCEDIMIENTO
DECLARE

V_RSP varchar2(200);
-- Empleados
V_OUT number; -- resultado que retorna el procedumiento
ID_INEXISTENTE number := 888; -- Identificador inexistente
BEGIN

  -- ERROR POR YA EXISTIR EL DEPARTAMENTO
  INV_MANTENIMIENTOS_PQ.INV_GEST_DEP_ALTA_PR('CONTABILIDAD', 'Departamento de contabilidad y finanzas',NULL,V_RSP,V_OUT);
  -- ERROR POR NO EXISTIR EL DEPARTAMENTO AL QUE SE ASIGNA LA SEDE
  INV_MANTENIMIENTOS_PQ.INV_GEST_SEDE_ALTA_PR('MARITIMO2','ES','Palma','07010','Av. del mar','3','Planta baja','',ID_INEXISTENTE, V_RSP, V_OUT);
  -- ERROR por no rellenar dato obligatorio (CP)
  INV_MANTENIMIENTOS_PQ.INV_GEST_SEDE_ALTA_PR('MARITIMO2','ES','Palma',NULL,'Av. del mar','3','Planta baja','',1, V_RSP, V_OUT);
  -- Error DNI no vlido, la letra no coincide
  INV_MANTENIMIENTOS_PQ.INV_GEST_EMPLEADO_ALTA_PR('12345678F','Daniel','Zafra','H','971234567',TO_DATE('04/09/1978', 'dd/mm/yyyy'),'dzafra14@uoc.edu',1,1,V_RSP,V_OUT);
  -- Error por no indicar el departamento al que pertenece
  INV_MANTENIMIENTOS_PQ.INV_GEST_EMPLEADO_ALTA_PR('86864583T','Daniel','Zafra','H','971234567',TO_DATE('04/09/1978', 'dd/mm/yyyy'),'dzafra14@uoc.edu',NULL,1,V_RSP,V_OUT);
  -- Error pon no indicar la sede donde se ubica este empleado
  INV_MANTENIMIENTOS_PQ.INV_GEST_EMPLEADO_ALTA_PR('29927851K','Antonio','Snchez','H','971999997',TO_DATE('14/09/1979', 'dd/mm/yyyy'),'asanchez@uoc.edu',1,ID_INEXISTENTE,V_RSP,V_OUT);
  -- Error por no existir el empleado que se nombra responsable
  INV_MANTENIMIENTOS_PQ.INV_GEST_DEP_MODIF_PR(1,NULL,NULL,ID_INEXISTENTE,V_RSP);
  -- Error CIF duplicado en proveedor
  INV_MANTENIMIENTOS_PQ.INV_GEST_PROVEEDOR_ALTA_PR('123456789','Ofimtica Valls','Cam de Son Rapinya 3r B','Bartolome Valls','bmvalls@gmail.com','971223344',V_RSP,V_OUT);
    -- Error por marca no existente
  INV_MANTENIMIENTOS_PQ.INV_GEST_PRODUCTO_ALTA_PR('Inspiron','2',ID_INEXISTENTE,'Sobremesa, Procesador Intel Core i7-5200U, Windows 10 Professional',V_RSP,V_OUT);
  -- Error por tipo de producto no existente
  INV_MANTENIMIENTOS_PQ.INV_GEST_PRODUCTO_ALTA_PR('LaserJet Enterprise M601n',ID_INEXISTENTE,'1','Impresora laser B/W',V_RSP,V_OUT);
  -- Error pedido validado por empleado inexsitente
  INV_PEDIDOS_PQ.INV_GEST_PED_ALTA_PR(TO_DATE('01/01/2014', 'dd/mm/yyyy'),ID_INEXISTENTE,'Pedido 1: Para su procesamiento necesita autorizacion',V_RSP,V_OUT);
  -- Error linea de pedido vinculado a pedido inexsitente
  INV_PEDIDOS_PQ.INV_GEST_PED_SOLICITA_PROD_PR (ID_INEXISTENTE,2,1,V_OUT); --linea de pedido 1 (sobremesa)
      -- Valida pedido inexistente
  INV_PEDIDOS_PQ.INV_GEST_PED_VALIDA_PR(ID_INEXISTENTE,1,TO_DATE('03/01/2014', 'dd/mm/yyyy'),'URGENTE!!!',V_OUT);
  -- Presupuesto erroneo. Pedido inexistente
  INV_PEDIDOS_PQ.INV_GEST_PED_ALTA_PRESUP_PR(TO_DATE('04/01/2014', 'dd/mm/yyyy'),TO_DATE('14/01/2014', 'dd/mm/yyyy'),7500,1,ID_INEXISTENTE,V_RSP,V_OUT);
  -- Presupuesto con proveedor inexistente
  INV_PEDIDOS_PQ.INV_GEST_PED_ALTA_PRESUP_PR(TO_DATE('04/01/2014', 'dd/mm/yyyy'),TO_DATE('14/01/2014', 'dd/mm/yyyy'),7500,ID_INEXISTENTE,1,V_RSP,V_OUT);
  
  
  -- Error. aprueba compra empleado inexistente 
  INV_PEDIDOS_PQ.INV_GEST_PED_APRUEBA_COMPRA_PR(1,ID_INEXISTENTE,TO_DATE('06/01/2014', 'dd/mm/yyyy'),1,'urgente','I',V_OUT);
     
        -- Error. aprueba compra de presupuesto inexistente
  INV_PEDIDOS_PQ.INV_GEST_PED_APRUEBA_COMPRA_PR(1,1,TO_DATE('06/01/2014', 'dd/mm/yyyy'),ID_INEXISTENTE,'urgente','I',V_OUT);

  -- Error pedido recibido no indica correctamente el pedido
  INV_PEDIDOS_PQ.INV_GEST_PED_RECIBIDO_PR(ID_INEXISTENTE,TO_DATE('16/01/2014', 'dd/mm/yyyy'),V_RSP);
  -- Error cod duplicado DEL DISPOSITIVO
  INV_DISPOSITIVOS_PQ.INV_GEST_DISP_ALTA_PR('12342611141',0,TO_DATE('16/01/2014', 'dd/mm/yyyy'),400,'Dispositivo 1: PC',NULL,1,1,1,V_RSP,V_OUT);
  -- Error no existe el producto 
  INV_DISPOSITIVOS_PQ.INV_GEST_DISP_ALTA_PR('12342611141',0,TO_DATE('16/01/2014', 'dd/mm/yyyy'),400,'Dispositivo 1: PC',NULL,ID_INEXISTENTE,1,1,V_RSP,V_OUT);
  -- Error tipo de movimiento inexistente
  INV_DISPOSITIVOS_PQ.INV_GEST_DISP_ALTA_MOV_PR(TO_DATE('17/01/2014', 'dd/mm/yyyy'),1,NULL,1,ID_INEXISTENTE,'Primera entrega del disp',V_RSP,V_OUT); 
  -- ERROR porque se aprueba pedido que no existe 
  INV_PEDIDOS_PQ.INV_GEST_PED_VALIDA_PR(ID_INEXISTENTE,1,TO_DATE('13/12/2015', 'dd/mm/yyyy'),'Pedido 3:INNECESARIO',V_RSP);
    -- ERROR porque se aprueba compra de pedido no autorizado por responsable del departamento 
  INV_PEDIDOS_PQ.INV_GEST_PED_APRUEBA_COMPRA_PR(3,1,TO_DATE('06/01/2014', 'dd/mm/yyyy'),1,'Intento aprobar auqnue no autorizado','I',V_RSP);
  -- Error al dar de alta inventario de sede erronea
  INVENTARIO_PQ.INV_GEST_INV_ALTA_PR(ID_INEXISTENTE,SYSDATE,1,V_RSP,V_OUT); 
  -- Empleado erroneo como responsable del inventario
  INVENTARIO_PQ.INV_GEST_INV_ALTA_PR(1,SYSDATE,ID_INEXISTENTE,V_RSP,V_OUT); 
  -- Error modificar departamento que no existe
  INV_MANTENIMIENTOS_PQ.INV_GEST_DEP_MODIF_PR(ID_INEXISTENTE,'TECNOLOGA Y COMUNICACIONES','Departamento de tecnologa, innovacin y desarrollo',3, v_RSP); 	
  -- error al Modifica responsable de departamento (no existe el responsable indicado)
  INV_MANTENIMIENTOS_PQ.INV_GEST_DEP_MODIF_PR(2,NULL,NULL,ID_INEXISTENTE,V_RSP);
  -- modifica empleado que no existe 
  INV_MANTENIMIENTOS_PQ.INV_GEST_EMPLEADO_MODIF_PR(ID_INEXISTENTE,NULL,NULL,NULL,NULL,'971285852',NULL,'trealea@yahoo.es',NULL,NULL,NULL,V_RSP); --modificaciones datos contacto
  -- modifica dispositivo que no existe
  INV_DISPOSITIVOS_PQ.INV_GEST_DISP_MANT_PR (ID_INEXISTENTE,NULL,NULL,NULL,TO_DATE('01/12/2015', 'dd/mm/yyyy'),'Fecha actualizada',NULL,NULL,NULL,NULL,V_RSP); --MODIFICACIN FECHA COMPRA
  -- Elimina empleado que no est de baja
  INV_MANTENIMIENTOS_PQ.INV_GEST_EMPLEADO_ELIMINA_PR(1,v_RSP);
END;